<template>
  <!-- Input container -->
  <label>
    <t-datepicker
      :id="id"
      v-model="vModel"
      :disabled="disabled"
      :v-model="vModel"
      :required="required"
      :name="name"
      :class="`${classes}`"
      :timepicker="timepicker"
      :lang="lang"
      :min-date="minDate"
      :date-format="dateFormat"
      :user-format="userFormat"
      :months-per-view="monthsPerView"
      :clearable="clearable"
      :label="label"
      :inline="inline"
      :placeholder="placeholder"
      :variant="variant"
      :datepicker="datepicker"
    >
      <template
        slot="day"
        slot-scope="{ day, dayFormatted }"
      >
        <slot
          name="day"
          :day="day"
          :day-formatted="dayFormatted"
        >
          <div class="leading-5">{{ dayFormatted }}</div>
        </slot>
      </template>
    </t-datepicker>
  </label>
</template>

<script>
import BaseInput from './BaseInput'
/**
 * Button component
 * @global
 */
export default {
  name: 'DatePicker',
  extends: BaseInput,
  props: {
    /**
     * value (to use v-model directive)
     *
     * See also how to [customize component v-model](https://vuejs.org/v2/guide/components-custom-events.html#Customizing-Component-v-model)
     */
    value: {
      type: String,
      default: ''
    },
    /**
     * Id
     */
    id: {
      type: String,
      default: ''
    },
    /**
     * 'lang'
     */
    lang: {
      type: String,
      default: undefined
    },
    /**
     * 'dateFormat'
     */
    dateFormat: {
      type: String,
      default: undefined
    },
    /**
     * 'userFormat'
     */
    userFormat: {
      type: String,
      default: undefined
    },
    /**
     * 'monthsPerView'
     */
    monthsPerView: {
      type: Number,
      default: undefined
    },
    /**
     * 'minDate'
     */
    minDate: {
      type: Date,
      default: undefined
    },
    /**
     * Tailwind variant for the button
     */
    variant: {
      type: String,
      default: ''
    },
    /**
     * Classes to add to the t-datepicker
     */
    classes: {
      type: String,
      default: ''
    },
    /**
     * label to add to the t-datepicker
     */
    label: {
      type: String,
      default: ''
    },
    /**
     * placeholder to add to the t-datepicker
     */
    placeholder: {
      type: String,
      default: ''
    },
    /**
     * Define if datepicker is datepicker
     */
    datepicker: {
      type: Boolean,
      default: true
    },
    /**
     * Define if datepicker is disabled
     */
    disabled: {
      type: Boolean,
      default: false
    },
    /**
     * Define if datepicker is required
     */
    required: {
      type: Boolean,
      default: false
    },
    /**
     * Define if add timepicker on t-datepicker
     */
    timepicker: {
      type: Boolean,
      default: false
    },
    /**
     * Define if add clearable on t-datepicker
     */
    clearable: {
      type: Boolean,
      default: false
    },
    /**
     * Define if add inline on t-datepicker
     */
    inline: {
      type: Boolean,
      default: false
    }
  }
}
</script>

<docs lang="md">

<h3 color="red">Examples</h3>

#### Basic

```jsx
<Datepicker variant="action">
  Click me
</Datepicker>
```
</docs>
